/*
	File:		CAProxyHooks.h

	Contains:	Typedefs for routines which are defined by CALib and called
				by the proxy part.  The CALib routines convert from OD to CA
				types and call the cooresponding CA handler if installed.

	Written by:	Rick Badertscher

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <1>	  5/13/95	RB		Created

	To Do:
*/


#ifndef _CAProxyHooks_
#define _CAProxyHooks_

#ifndef _ODTYPES_
#include <ODTypes.h>
#endif

class	ODDraft;
class	ODFrame;
class	ODShape;
class	ODFacet;
class	ODTransform;

typedef void		(*CAProxyHookAdjustBorder)	(	CAAdjustBorderProc adjustBorderProc,
													ODDraft*		document,
													ODFrame*		frame,
													ODShape*		shape);


typedef	void		(*CAProxyHookFrameShapeRequest) (CAFrameShapeRequestHandler	handler,
													ODDraft*			document,
													ODFrame*			frame,
													ODShape*			shape);

													
#endif
