/*
	File:		CAProxyPart.cpp

	Contains:	Implementation of the SOM class CAProxyPart

	Written by:	Tantek elik

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.


	Change History (most recent first):

		<11>	 5/06/95	SJF		Cleanup Drag & Drop
		<10>	  4/7/95	SJF		CreateLink now returns an ODLinkSource*.
									See revision <11> comments on CAProxyPart.h
		 <9>	 4/04/95	RB		Fixed for b1c14
		 <8>	 3/15/95	SJF		Merge changes with the stuff RickB checked
									in
		 <7+>	 3/15/95	SJF		Add support for CAProxyExtension
		 <4+>	 2/20/95	SJF		Mergin in Ricks changes, put code in CAProxyPart segment
		 <4>	 2/13/95	SJF		Interim checkin to update project database
		 <1>	  2/? 95	SJF		Who knows what happens, this is a SOM generated file...
		 <0>	11/16/94	SJF		first written
		 
	To Do:
*/

#ifndef SOM_ODFrame_xh
#include <Frame.xh>
#endif

#ifndef SOM_ODFacet_xh
#include <Facet.xh>
#endif

#ifndef SOM_ODShape_xh
#include <Shape.xh>
#endif

#ifndef SOM_ODDraft_xh
#include <Draft.xh>
#endif

#ifndef SOM_ODStorageUnit_xh
#include <StorageU.xh>
#endif

#ifndef SOM_ODTransform_xh
#include <Trnsform.xh>
#endif

#ifndef SOM_ODWindow_xh
#include <Window.xh>
#endif

#ifndef __QUICKDRAW__
#include <Quickdraw.h>
#endif

#define Utility_som_CAProxyPart_Class_Source
#define VARIABLE_MACROS
#include "som_CAProxyPart.xih"

#ifndef _CAPROXYPART_
#include "CAProxyPart.h"
#endif


#ifndef _EXCEPT_
#include <Except.h>
#endif

#pragma segment somCAProxyPart

SOM_Scope void  SOMLINK som_CAProxyPart__somInit(Utility_som_CAProxyPart *somSelf)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__somInit");
    
    _fCPPart = NULL;

    Utility_som_CAProxyPart_parent_ODPart_somInit(somSelf);

   // _fCPPart = new CAProxyPart;

}

SOM_Scope void  SOMLINK som_CAProxyPart__somUninit(Utility_som_CAProxyPart *somSelf)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__somUninit");
	
	if (_fCPPart) delete _fCPPart;
	
    Utility_som_CAProxyPart_parent_ODPart_somUninit(somSelf);
}

SOM_Scope ODBoolean  SOMLINK som_CAProxyPart__HasExtension(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODType extensionName)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__HasExtension");

	return (_fCPPart->HasExtension(ev,extensionName));
}

SOM_Scope ODExtension*  SOMLINK som_CAProxyPart__AcquireExtension(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODType extensionName)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__AcquireExtension");

	return (_fCPPart->AcquireExtension(ev,extensionName));
}

SOM_Scope void  SOMLINK som_CAProxyPart__ReleaseExtension(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODExtension* extension)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__ReleaseExtension");

	_fCPPart->ReleaseExtension(ev,extension);
}

SOM_Scope ODSize  SOMLINK som_CAProxyPart__Purge(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODSize size)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__Purge");

	//ODStorageUnit* su = somSelf->GetStorageUnit(ev);
	//return su -> Purge(ev,  size );

	return (_fCPPart->Purge(ev,size));
}

SOM_Scope void  SOMLINK som_CAProxyPart__Release(Utility_som_CAProxyPart *somSelf, Environment *ev)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__Release");
    Utility_som_CAProxyPart_parent_ODPart_Release(somSelf,ev);
    _fCPPart->Release(ev);

}

SOM_Scope void  SOMLINK som_CAProxyPart__ReleaseAll(Utility_som_CAProxyPart *somSelf, Environment *ev)
{
   Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__ReleaseAll");
    _fCPPart->ReleaseAll(ev);
    Utility_som_CAProxyPart_parent_ODPart_ReleaseAll(somSelf,ev);
}

SOM_Scope void  SOMLINK som_CAProxyPart__Externalize(Utility_som_CAProxyPart *somSelf, Environment *ev)
{
   Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__Externalize");

    Utility_som_CAProxyPart_parent_ODPart_Externalize(somSelf,ev);
    _fCPPart->Externalize(ev);

}

SOM_Scope void  SOMLINK som_CAProxyPart__CloneInto(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODDraftKey key,
		ODStorageUnit* toSU,
		ODFrame* scope)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__CloneInto");

	Utility_som_CAProxyPart_parent_ODPart_CloneInto(somSelf,ev,key,toSU,scope);
    _fCPPart->CloneInto(ev,key,toSU,scope);


}

SOM_Scope void  SOMLINK som_CAProxyPart__InitPart(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODStorageUnit* storageUnit,
		ODPart* partWrapper)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__InitPart");
	
	Utility_som_CAProxyPart_parent_ODPart_InitPart(somSelf,ev,storageUnit,partWrapper);
	
	if (!_fCPPart) _fCPPart = new CAProxyPart;

	_fCPPart->InitPart(ev,storageUnit, (ODPart*)partWrapper);
	

}

SOM_Scope void  SOMLINK som_CAProxyPart__InitPartFromStorage(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODStorageUnit* storageUnit,
		ODPart* partWrapper)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__InitPartFromStorage");

    Utility_som_CAProxyPart_parent_ODPart_InitPartFromStorage(somSelf,ev,storageUnit,partWrapper);
	
	if (!_fCPPart) _fCPPart = new CAProxyPart;

	_fCPPart->InitPartFromStorage(ev,storageUnit, (ODPart*)partWrapper);


}

SOM_Scope void  SOMLINK som_CAProxyPart__FulfillPromise(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODStorageUnitView* promiseSUView)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    _fCPPart->FulfillPromise(ev,promiseSUView);
}

SOM_Scope void  SOMLINK som_CAProxyPart__DropCompleted(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODPart* destPart,
		ODDropResult dropResult)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    _fCPPart->DropCompleted(ev,destPart,dropResult);
}

SOM_Scope ODDragResult  SOMLINK som_CAProxyPart__DragEnter(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODDragItemIterator* dragInfo,
		ODFacet* facet,
		ODPoint* where)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    return (_fCPPart->DragEnter(ev,dragInfo,facet,where));
}

SOM_Scope ODDragResult  SOMLINK som_CAProxyPart__DragWithin(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODDragItemIterator* dragInfo,
		ODFacet* facet,
		ODPoint* where)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    return (_fCPPart->DragWithin(ev,dragInfo,facet,where));
}

SOM_Scope void  SOMLINK som_CAProxyPart__DragLeave(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFacet* facet,
		ODPoint* where)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    _fCPPart->DragLeave(ev,facet,where);
}

SOM_Scope ODDropResult  SOMLINK som_CAProxyPart__Drop(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODDragItemIterator* dropInfo,
		ODFacet* facet,
		ODPoint* where)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    return (_fCPPart->Drop(ev,dropInfo,facet,where));
}

SOM_Scope ODStorageUnit*  SOMLINK som_CAProxyPart__AcquireContainingPartProperties(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* frame)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__AcquireContainingPartProperties");

    return (_fCPPart->AcquireContainingPartProperties(ev,frame));
}

SOM_Scope void  SOMLINK som_CAProxyPart__ContainingPartPropertiesUpdated(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* frame,
		ODStorageUnit* propertyUnit)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    _fCPPart->ContainingPartPropertiesUpdated(ev,frame,propertyUnit);
}

SOM_Scope ODBoolean  SOMLINK som_CAProxyPart__RevealFrame(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* embeddedFrame,
		ODShape* revealShape)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    return (_fCPPart->RevealFrame(ev,embeddedFrame,revealShape));
}

SOM_Scope void  SOMLINK som_CAProxyPart__EmbeddedFrameSpec(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* embeddedFrame,
		ODObjectSpec* spec)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    _fCPPart->EmbeddedFrameSpec(ev,embeddedFrame,spec);
}

SOM_Scope ODEmbeddedFramesIterator*  SOMLINK som_CAProxyPart__CreateEmbeddedFramesIterator(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* frame)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__CreateEmbeddedFramesIterator");

    return (_fCPPart->CreateEmbeddedFramesIterator(ev,frame));
}

SOM_Scope void  SOMLINK som_CAProxyPart__DisplayFrameAdded(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* frame)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__DisplayFrameAdded");

    _fCPPart->DisplayFrameAdded(ev,frame);
}

SOM_Scope void  SOMLINK som_CAProxyPart__DisplayFrameRemoved(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* frame)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__DisplayFrameRemoved");

    _fCPPart->DisplayFrameRemoved(ev,frame);
}

SOM_Scope void  SOMLINK som_CAProxyPart__DisplayFrameConnected(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* frame)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__DisplayFrameConnected");

    _fCPPart->DisplayFrameConnected(ev,frame);
}

SOM_Scope void  SOMLINK som_CAProxyPart__DisplayFrameClosed(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* frame)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__DisplayFrameClosed");

    _fCPPart->DisplayFrameClosed(ev,frame);
}

SOM_Scope void  SOMLINK som_CAProxyPart__AttachSourceFrame(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* frame,
		ODFrame* sourceFrame)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__AttachSourceFrame");

    _fCPPart->AttachSourceFrame(ev,frame,sourceFrame);
}

SOM_Scope void  SOMLINK som_CAProxyPart__FrameShapeChanged(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* frame)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__FrameShapeChanged");

    _fCPPart->FrameShapeChanged(ev,frame);
}

SOM_Scope void  SOMLINK som_CAProxyPart__ViewTypeChanged(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* frame)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__ViewTypeChanged");

    _fCPPart->ViewTypeChanged(ev,frame);
}

SOM_Scope void  SOMLINK som_CAProxyPart__PresentationChanged(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* frame)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__PresentationChanged");

    _fCPPart->PresentationChanged(ev,frame);
}

SOM_Scope void  SOMLINK som_CAProxyPart__SequenceChanged(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* frame)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__SequenceChanged");

    _fCPPart->SequenceChanged(ev,frame);
}

SOM_Scope void  SOMLINK som_CAProxyPart__WritePartInfo(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODInfoType partInfo,
		ODStorageUnitView* storageUnitView)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__WritePartInfo");

    _fCPPart->WritePartInfo(ev,partInfo,storageUnitView);
}

SOM_Scope ODInfoType  SOMLINK som_CAProxyPart__ReadPartInfo(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* frame,
		ODStorageUnitView* storageUnitView)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__ReadPartInfo");

    return (_fCPPart->ReadPartInfo(ev,frame,storageUnitView));
}

SOM_Scope void  SOMLINK som_CAProxyPart__ClonePartInfo(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODDraftKey key,
		ODInfoType partInfo,
		ODStorageUnitView* storageUnitView,
		ODFrame* scope)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__ClonePartInfo");

    _fCPPart->ClonePartInfo(ev, key, partInfo, storageUnitView, scope);
}

SOM_Scope ODID  SOMLINK som_CAProxyPart__Open(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* frame)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__Open");

	return (_fCPPart->Open(ev,frame));
}

SOM_Scope ODBoolean  SOMLINK som_CAProxyPart__EditInLinkAttempted(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* frame)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__EditInLinkAttempted");

    return (Utility_som_CAProxyPart_parent_ODPart_EditInLinkAttempted(somSelf,ev,frame));
}

SOM_Scope ODFrame*  SOMLINK som_CAProxyPart__RequestEmbeddedFrame(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* containingFrame,
		ODFrame* baseFrame,
		ODShape* frameShape,
		ODPart* embedPart,
		ODTypeToken viewType,
		ODTypeToken presentation,
		ODBoolean isOverlaid)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__RequestEmbeddedFrame");

	return (_fCPPart->RequestEmbeddedFrame(ev,containingFrame,baseFrame,frameShape,embedPart,viewType,presentation,isOverlaid));
}

SOM_Scope void  SOMLINK som_CAProxyPart__RemoveEmbeddedFrame(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* embeddedFrame)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__RemoveEmbeddedFrame");

    _fCPPart->RemoveEmbeddedFrame(ev,embeddedFrame);
}

SOM_Scope ODShape*  SOMLINK som_CAProxyPart__RequestFrameShape(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* embeddedFrame,
		ODShape* frameShape)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__RequestFrameShape");

	return (_fCPPart->RequestFrameShape(ev,embeddedFrame,frameShape));
}

SOM_Scope void  SOMLINK som_CAProxyPart__UsedShapeChanged(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* embeddedFrame)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__UsedShapeChanged");

    _fCPPart->UsedShapeChanged(ev,embeddedFrame);
}

SOM_Scope ODShape*  SOMLINK som_CAProxyPart__AdjustBorderShape(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFacet* embeddedFacet,
		ODShape* shape)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__AdjustBorderShape");

    return (_fCPPart->AdjustBorderShape(ev,embeddedFacet,shape));
}

SOM_Scope void  SOMLINK som_CAProxyPart__FacetAdded(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFacet* facet)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__FacetAdded");

    _fCPPart->FacetAdded(ev,facet);
}

SOM_Scope void  SOMLINK som_CAProxyPart__FacetRemoved(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFacet* facet)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__FacetRemoved");

	_fCPPart->FacetRemoved(ev,facet);
}

SOM_Scope void  SOMLINK som_CAProxyPart__CanvasChanged(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFacet* facet)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__CanvasChanged");

	_fCPPart->CanvasChanged(ev,facet);
}

SOM_Scope void  SOMLINK som_CAProxyPart__GeometryChanged(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFacet* facet,
		ODBoolean clipShapeChanged,
		ODBoolean externalTransformChanged)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__GeometryChanged");

	_fCPPart->GeometryChanged(ev,facet,clipShapeChanged,externalTransformChanged);
}

SOM_Scope void  SOMLINK som_CAProxyPart__Draw(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFacet* facet,
		ODShape* invalidShape)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__Draw");

	_fCPPart->Draw(ev,facet,invalidShape);
}

SOM_Scope void  SOMLINK som_CAProxyPart__CanvasUpdated(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODCanvas* canvas)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__CanvasUpdated");

	_fCPPart->CanvasUpdated(ev,canvas);
}

SOM_Scope void  SOMLINK som_CAProxyPart__HighlightChanged(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFacet* facet)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__HighlightChanged");

	_fCPPart->HighlightChanged(ev,facet);
}

SOM_Scope ODULong  SOMLINK som_CAProxyPart__GetPrintResolution(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* frame)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__GetPrintResolution");

	return (_fCPPart->GetPrintResolution(ev,frame));
}

SOM_Scope ODLinkSource*  SOMLINK som_CAProxyPart__CreateLink(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODByteArray* data)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__CreateLink");

	return (_fCPPart->CreateLink(ev,data));
}

SOM_Scope void  SOMLINK som_CAProxyPart__LinkUpdated(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODLink* updatedLink,
		ODUpdateID change)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__LinkUpdated");

	_fCPPart->LinkUpdated(ev,updatedLink,change);
}

SOM_Scope void  SOMLINK som_CAProxyPart__RevealLink(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODLinkSource* linkSource)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__RevealLink");

	_fCPPart->RevealLink(ev,linkSource);
}

SOM_Scope void  SOMLINK som_CAProxyPart__EmbeddedFrameUpdated(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* frame,
		ODUpdateID change)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__EmbeddedFrameUpdated");

    Utility_som_CAProxyPart_parent_ODPart_EmbeddedFrameUpdated(somSelf,ev,frame,change);
}

SOM_Scope void  SOMLINK som_CAProxyPart__LinkStatusChanged(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* frame)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__LinkStatusChanged");

	_fCPPart->LinkStatusChanged(ev,frame);
}

SOM_Scope ODBoolean  SOMLINK som_CAProxyPart__BeginRelinquishFocus(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame,
		ODFrame* proposedFrame)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__BeginRelinquishFocus");

	return (_fCPPart->BeginRelinquishFocus(ev,focus,ownerFrame,proposedFrame));
}

SOM_Scope void  SOMLINK som_CAProxyPart__CommitRelinquishFocus(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame,
		ODFrame* proposedFrame)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__CommitRelinquishFocus");

	_fCPPart->CommitRelinquishFocus(ev,focus,ownerFrame,proposedFrame);
}

SOM_Scope void  SOMLINK som_CAProxyPart__AbortRelinquishFocus(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame,
		ODFrame* proposedFrame)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__AbortRelinquishFocus");

	_fCPPart->AbortRelinquishFocus(ev,focus,ownerFrame,proposedFrame);
}

SOM_Scope void  SOMLINK som_CAProxyPart__FocusAcquired(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__FocusAcquired");

	_fCPPart->FocusAcquired(ev,focus,ownerFrame);
}

SOM_Scope void  SOMLINK som_CAProxyPart__FocusLost(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__FocusLost");

	_fCPPart->FocusLost(ev,focus,ownerFrame);
}

SOM_Scope void  SOMLINK som_CAProxyPart__ExternalizeKinds(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODTypeList* kindset)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__ExternalizeKinds");

    _fCPPart->ExternalizeKinds(ev,kindset);
}

SOM_Scope void  SOMLINK som_CAProxyPart__ChangeKind(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODType kind)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__ChangeKind");

    _fCPPart->ChangeKind(ev,kind);
}

SOM_Scope ODBoolean  SOMLINK som_CAProxyPart__HandleEvent(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODEventData* event,
		ODFrame* frame,
		ODFacet* facet,
		ODEventInfo* eventInfo)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__HandleEvent");

    ODBoolean	retval = kODFalse;
    
    SOM_TRY
    	retval = _fCPPart->HandleEvent(ev,event,frame,facet,eventInfo);
    SOM_ENDTRY
    
    return (retval);
}

SOM_Scope void  SOMLINK som_CAProxyPart__AdjustMenus(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODFrame* frame)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__AdjustMenus");

    _fCPPart->AdjustMenus(ev,frame);
}

SOM_Scope void  SOMLINK som_CAProxyPart__UndoAction(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODActionData* actionState)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__UndoAction");

    _fCPPart->UndoAction(ev,actionState);
}

SOM_Scope void  SOMLINK som_CAProxyPart__RedoAction(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODActionData* actionState)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__RedoAction");

    _fCPPart->RedoAction(ev,actionState);
}

SOM_Scope void  SOMLINK som_CAProxyPart__DisposeActionState(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODActionData* actionState,
		ODDoneState doneState)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__DisposeActionState");

    _fCPPart->DisposeActionState(ev,actionState,doneState);
}

SOM_Scope void  SOMLINK som_CAProxyPart__WriteActionState(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODActionData* actionState,
		ODStorageUnitView* storageUnitView)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__WriteActionState");

    _fCPPart->WriteActionState(ev,actionState,storageUnitView);
}

SOM_Scope ODActionData  SOMLINK som_CAProxyPart__ReadActionState(Utility_som_CAProxyPart *somSelf, Environment *ev,
		ODStorageUnitView* storageUnitView)
{
    Utility_som_CAProxyPartData *somThis = Utility_som_CAProxyPartGetData(somSelf);
    Utility_som_CAProxyPartMethodDebug("Utility_som_CAProxyPart","som_CAProxyPart__ReadActionState");

    return (_fCPPart->ReadActionState(ev,storageUnitView));
}
