/*
	File:		CAProxyPartInit.cpp

	Contains:	Init routines

	Written by:	Tantek elik

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		<14>	 5/06/95	SJF		Cleanup Drag & Drop
		<10>	 4/19/95	RB		Mods for b1c18 compliance.
		<9+>	 4/11/95	SJF		Working on initialization sequence for
									ProxyPart & ProxyExtension
		 <8>	 4/02/95	RB		Changing UtilitiesCFMInit() to InitODMemory()
		 <7>	 3/15/95	SJF		I don't know how I got an older version of
									the file, but it's the same as the last
									version checked in , so WTF???
		 <7>	 3/15/95	SJF		WTF knows?!
		 <4+>	 2/28/95	SJF		Add debug statements to CFM & SOM init routines
		 <4>	 2/20/95	SJF		Merge in changes from RickB
		 <3>	 2/13/95	SJF		Interim checkin to update project database
		 <0>	11/16/94	SJF		first written
		 
	To Do:

*/

#ifndef __SOM__
#include <som.xh>
#endif

#ifndef __SOMOBJ__
#include <somobj.xh>
#endif

#ifndef __USERSRCM__
#include <UseRsrcM.h>
#endif

#ifndef __FRAGLOAD__
#include <FragLoad.h>
#endif

#ifndef SOM_Utility_som_CAProxyPart_xh
#include "som_CAProxyPart.xh"
#endif

#ifndef _CALIB_
#include "CALib.h"
#endif

#ifndef SOM_CAProxyExtension_xh
#include "CAProxyExtension.xh"
#endif

#ifndef __ODMemory__
#include "ODMemory.h"
#endif



//#define qDebug 1

#if qDebug
	#define 	WeBeHere(StringPtr) DebugStr(StringPtr)
#else
	#define 	WeBeHere(StringPtr)
#endif


#pragma segment somCAProxyPartInit

#if 0

SOMEXTERN void SOMLINK CAProxyPartSOMInit (long, long, string );

SOMEXTERN void SOMLINK CAProxyPartSOMInit (long majorVersion, 
                                       long minorVersion, 
                                       string className)
{
	WeBeHere( "\pCAProxyPartNewClass");
	
	Utility_som_CAProxyPartNewClass(majorVersion, minorVersion);
	//CAProxyExtensionNewClass (majorVersion, minorVersion);
}
#endif


extern "C" pascal OSErr CAProxyPartCFMInit (CFragInitBlockPtr initBlkPtr);

pascal OSErr CAProxyPartCFMInit (CFragInitBlockPtr initBlkPtr)
{
	WeBeHere( "\pCAProxyPartCFMInit");
	
	OSErr err1 = InitODMemory();
	OSErr err2 = InitLibraryResources(initBlkPtr);

	ODMemoryHeapID	heap = ODGetDefaultHeap();
	return err2;

}

